require 'pp'

class Movie
  REGULAR=0
  NEW_RELEASE=1
  CHILDRENS=2

  attr_reader :title
  attr_accessor :price_code

  def initialize(title, price_code)
    @title, @price_code = title, price_code
  end
end

matrix=Movie.new('Matrix', Movie::REGULAR)
mj=Movie.new('MJ', Movie::NEW_RELEASE)
totoro=Movie.new('Totoro', Movie::CHILDRENS)
gundam=Movie.new('Gundam', Movie::CHILDRENS)
pp mj
p mj.title
p totoro.price_code
#p totoro.price_code=Movie::REGULAR
#p mj.title="Michael Jackson"

class Rental
  attr_reader :movie, :days_rented
  def initialize(movie, days_rented)
    @movie, @days_rented = movie, days_rented
  end

  def charge
    result=0
    case movie.price_code
    when Movie::REGULAR
      result +=2
      result += (days_rented-2)*1.5 if days_rented > 2
    when Movie::NEW_RELEASE
      result += days_rented*3
    when Movie::CHILDRENS
      result +=1.5
      result += (days_rented-3)*1.5 if days_rented > 3
    end
    return result
  end

  def frequent_renter_points
    (movie.price_code==Movie::NEW_RELEASE && days_rented > 1) ? 2 : 1
  end
end

class Customer
  attr_reader :name
  def initialize(name)
    @name=name
    @rentals = []
  end

  def add_rental(arg)
    @rentals << arg
  end

  def statement
    frequent_renter_points = 0
    result="Rental Record for #{@name}\n"
    @rentals.each do |element|
      frequent_renter_points += element.frequent_renter_points
      result += "\t"+element.movie.title + "\t"+element.charge.to_s + "\n"
    end
    result += "Amount owed is #{total_charge}\n"
    result += "You earned #{frequent_renter_points} frequent renter points"
    result
  end

  def total_charge
    result = 0
    @rentals.each do |element|
      result += element.charge
    end
    result
  end
end

me=Customer.new('Nishitani')
me.add_rental(Rental.new(matrix,2))
me.add_rental(Rental.new(mj,4))
me.add_rental(Rental.new(totoro,6))
me.add_rental(Rental.new(gundam,3))
#pp me
print me.statement+ "\n"
